	CenterText				PROTO
	DrawTextCenter			PROTO
	DrawTextLeft			PROTO
	TextOutCenter			PROTO
	TextOutLeftCalc			PROTO

.code

DrawTextCenter proc
	invoke DrawText, hDC, addr DT_Ctr_line1, -1, addr RT, DT_SINGLELINE + DT_CENTER + DT_TOP	; Bad flickering
	invoke SetTextColor, hDC, 0FFFFFFh
	invoke DrawText, hDC, addr DT_Ctr_line2, -1, addr RT, DT_SINGLELINE + DT_CENTER + DT_VCENTER	; Bad flickering
	invoke SetTextColor, hDC, hFG_Brush
	invoke DrawText, hDC, addr DT_Ctr_line3, -1, addr RT, DT_SINGLELINE + DT_CENTER + DT_BOTTOM	; Bad flickering
	ret
DrawTextCenter endp

DrawTextLeft proc
	invoke DrawText, hDC, addr DT_Lft_line1, -1, addr RT, 0
	invoke SetTextColor, hDC, 0FFFFFFh
	invoke DrawText, hDC, addr DT_Lft_line2, -1, addr RT, DT_SINGLELINE + DT_LEFT + DT_VCENTER	; Bad flickering
	invoke SetTextColor, hDC, hFG_Brush
	invoke DrawText, hDC, addr DT_Lft_line3, -1, addr RT, DT_SINGLELINE + DT_LEFT + DT_BOTTOM	; Bad flickering
	ret
DrawTextLeft endp

TextOutCenter proc
	invoke lstrlen, addr TO_Ctr_line1
	invoke GetTextExtentPoint32, hDC, addr TO_Ctr_line1, eax, addr PT_line1
; Get x position of all lines.
	mov eax, RT.right
	sub eax, RT.left
	shr eax, 1			; eax/2. Center of rectangle
	push eax			; Width of rectangel
	mov ebx, PT_line1.x	; Width of string.
	shr ebx, 1			; Center of string.
	sub eax, ebx		; x pos of string start.
	add eax, RT.left
	mov PT_line1.x, eax
; Get y position of line1.
	mov eax, RT.top
	mov PT_line1.y, eax	; y pos of string start.
	invoke TextOut, hDC, PT_line1.x, PT_line1.y, addr TO_Ctr_line1, sizeof TO_Ctr_line1 -1	; Bad flickering
	
	invoke lstrlen, addr TO_Ctr_line2
	invoke GetTextExtentPoint32, hDC, addr TO_Ctr_line2, eax, addr PT_line2
; Get y position of line2.
	pop eax				; Width of rectangel
	push eax
	mov ebx, PT_line2.x	; Width of string.
	shr ebx, 1			; Center of string.
	sub eax, ebx		; x pos of string start.
	add eax, RT.left
	mov PT_line2.x, eax
; Get y position of line1.
	mov eax, RT.bottom
	sub eax, RT.top
	shr eax, 1			; VCenter of rect.
	mov ebx, PT_line2.y
	shr ebx, 1			; VCenter of font.
	sub eax, ebx
	add eax, RT.top
	mov PT_line2.y, eax	; y pos of string start.
	invoke SetTextColor, hDC, 0FFFFFFh
	invoke TextOut, hDC, PT_line2.x, PT_line2.y, addr TO_Ctr_line2, sizeof TO_Ctr_line2 -1	; Bad flickering
	
	invoke lstrlen, addr TO_Ctr_line3
	invoke GetTextExtentPoint32, hDC, addr TO_Ctr_line3, eax, addr PT_line3
; Get x position of line3.
	pop eax				; Width of rectangel
	mov ebx, PT_line3.x	; Width of string.
	shr ebx, 1			; Center of string.
	sub eax, ebx		; x pos of string start.
	add eax, RT.left
	mov PT_line3.x, eax
; Get y position of line3.
	mov eax, RT.bottom
	sub eax, PT_line3.y
	mov PT_line3.y, eax	; y pos of string start.
	invoke SetTextColor, hDC, hFG_Brush
	invoke TextOut, hDC, PT_line3.x, PT_line3.y, addr TO_Ctr_line3, sizeof TO_Ctr_line3 -1	; Bad flickering
	ret
TextOutCenter endp

TextOutLeftCalc proc
; Get y position of line1.
	invoke TextOut, hDC, RT.left, RT.top, addr TO_Lft_line1, sizeof TO_Lft_line1 -1	; Best
	
	invoke lstrlen, addr TO_Lft_line2
	invoke GetTextExtentPoint32, hDC, addr TO_Lft_line2, eax, addr PT_line2
	mov eax, RT.bottom
	sub eax, RT.top
	shr eax, 1			; VCenter of rect.
	mov ebx, PT_line2.y
	shr ebx, 1			; VCenter of font.
	sub eax, ebx
	add eax, RT.top
	mov PT_line2.y, eax	; y pos of string start.
	invoke SetTextColor, hDC, 0FFFFFFh
	invoke TextOut, hDC, RT.left, PT_line2.y, addr TO_Lft_line2, sizeof TO_Lft_line2 -1	; Best
	
	invoke lstrlen, addr TO_Lft_line3
	invoke GetTextExtentPoint32, hDC, addr TO_Lft_line3, eax, addr PT_line3
	mov eax, RT.bottom
	sub eax, PT_line3.y
	mov PT_line3.y, eax	; y pos of string start.
	invoke SetTextColor, hDC, hFG_Brush
	invoke TextOut, hDC, RT.left, PT_line3.y, addr TO_Lft_line3, sizeof TO_Lft_line3 -1	; Best
	ret
TextOutLeftCalc endp
