	InitData			PROTO
	ScaleTB				PROTO
	InitControls		PROTO
	CompRGB				PROTO :DWORD,  :DWORD,  :DWORD
	SelectColor			PROTO :DWORD
	CopyColor			PROTO :DWORD
	
.data
	STCClass 		db "STATIC", 0
	
.data?
	
.code

InitData proc
	mov RT.left, 15
	mov RT.top, 252
	mov RT.right, 344
	mov RT.bottom, 320

	mov LF.lfHeight, -12
	mov LF.lfWidth, 0
	mov LF.lfEscapement, 0
	mov LF.lfOrientation, 0
	mov LF.lfWeight, 400
	mov LF.lfItalic, 0
	mov LF.lfUnderline, 0
	mov LF.lfStrikeOut, 0
	mov LF.lfCharSet, 0
	mov LF.lfOutPrecision, 3
	mov LF.lfClipPrecision, 2
	mov LF.lfQuality, 1
	mov LF.lfPitchAndFamily, 34
	lea eax,LF.lfFaceName
	invoke wsprintf,eax,addr fontFace	; Load font name.

	mov hFont, rv(CreateFontIndirect, addr LF)
	

	; CHOOSEFONT structure
	mov edi, offset CF
	mov ecx, sizeof CHOOSEFONT
	mov al, 0
	rep stosb
	
	mov	CF.lStructSize,SIZEOF CHOOSEFONT
	push	hWnd
	pop	CF.hWndOwner
	lea eax,LF
	mov	CF.lpLogFont,eax
	mov	CF.Flags,CF_EFFECTS OR CF_SCREENFONTS OR CF_LIMITSIZE OR\
		CF_FORCEFONTEXIST OR CF_INITTOLOGFONTSTRUCT
	mov	CF.hDC,0
	mov	CF.iPointSize,0
;	invoke GetSysColor,COLOR_WINDOWTEXT
;	mov	CF.rgbColors,eax
;	mov	CF.lCustData,0
;	mov	CF.lpfnHook,0
;	mov	CF.lpTemplateName,0
;	mov	CF.hInstance,0
;	mov	CF.lpszStyle,0
;	mov	CF.nFontType,0
;	mov	CF.Alignment,0
	mov	CF.nSizeMin,8
	mov	CF.nSizeMax,28
	
	
	ret
InitData endp

ScaleTB proc
;-------------Scale Text Trackbars---------
	mov hTBR_TXT_RED, rv(GetDlgItem, hWnd, TBR_TXT_RED)
	invoke SendMessage, hTBR_TXT_RED, TBM_SETRANGE, FALSE, 255 * 10000h + 0
	mov hTBR_TXT_GREEN, rv(GetDlgItem, hWnd, TBR_TXT_GREEN)
	invoke SendMessage, hTBR_TXT_GREEN, TBM_SETRANGE, FALSE, 255 * 10000h + 0
	mov hTBR_TXT_BLUE, rv(GetDlgItem, hWnd, TBR_TXT_BLUE)
	invoke SendMessage, hTBR_TXT_BLUE, TBM_SETRANGE, FALSE, 255 * 10000h + 0
;-------------Scale Background Trackbars---------
	mov hTBR_BGD_RED, rv(GetDlgItem, hWnd, TBR_BGD_RED)
	invoke SendMessage, hTBR_BGD_RED, TBM_SETRANGE, FALSE, 255 * 10000h + 0
	mov hTBR_BGD_GREEN, rv(GetDlgItem, hWnd, TBR_BGD_GREEN)
	invoke SendMessage, hTBR_BGD_GREEN, TBM_SETRANGE, FALSE, 255 * 10000h + 0
	mov hTBR_BGD_BLUE, rv(GetDlgItem, hWnd, TBR_BGD_BLUE)
	invoke SendMessage, hTBR_BGD_BLUE, TBM_SETRANGE, FALSE, 255 * 10000h + 0
	ret

ScaleTB endp
InitControls proc
	
; Initialize colors and trackbars.
	mov hSTC_TXT_RED, rv(GetDlgItem, hWnd, STC_TXT_RED)
	mov hSTC_TXT_GREEN, rv(GetDlgItem, hWnd, STC_TXT_GREEN)
	mov hSTC_TXT_BLUE, rv(GetDlgItem, hWnd, STC_TXT_BLUE)
	mov hSTC_BGD_RED, rv(GetDlgItem, hWnd, STC_BGD_RED)
	mov hSTC_BGD_GREEN, rv(GetDlgItem, hWnd, STC_BGD_GREEN)
	mov hSTC_BGD_BLUE, rv(GetDlgItem, hWnd, STC_BGD_BLUE)

	mov hEDT_TXT_CLR, rv(GetDlgItem, hWnd, EDT_TXT_CLR)
	mov hEDT_BGD_CLR, rv(GetDlgItem, hWnd, EDT_BGD_CLR)

	mov bgdRed, 127
	mov bgdGreen, 127
	mov bgdBlue, 127
	invoke SendMessage, hTBR_BGD_RED, TBM_SETPOS, TRUE, bgdRed
	invoke SendMessage, hTBR_BGD_GREEN, TBM_SETPOS, TRUE, bgdGreen
	invoke SendMessage, hTBR_BGD_BLUE, TBM_SETPOS, TRUE, bgdBlue
	
	mov txtRed, 0
	mov txtGreen, 127
	mov txtBlue, 255
	invoke SendMessage, hTBR_TXT_RED, TBM_SETPOS, TRUE, txtRed
	invoke SendMessage, hTBR_TXT_GREEN, TBM_SETPOS, TRUE, txtGreen
	invoke SendMessage, hTBR_TXT_BLUE, TBM_SETPOS, TRUE, txtBlue

	ret
InitControls endp

CompRGB proc red:DWORD, green:DWORD, blue:DWORD
		mov eax, blue
		xor ebx, green
		shl ebx, 24
		shld eax, ebx, 8
		xor ebx, red
		shl ebx, 24
		shld eax, ebx, 8
	ret

CompRGB endp

SelectColor proc id:DWORD
	LOCAL cc:CHOOSECOLOR
	
	mov cc.lStructSize, sizeof cc
	push hWnd
	pop cc.hwndOwner
	push hInstance
	pop cc.hInstance
	lea eax, colorRef
	mov cc.lpCustColors, eax
	mov cc.Flags, CC_RGBINIT or CC_FULLOPEN;
	mov cc.lCustData, 0
	mov cc.lpfnHook, NULL;
	mov cc.lpTemplateName, NULL;
	xor eax, eax
	
	invoke ChooseColor, addr cc
	
	mov eax, cc.rgbResult
	and eax, 0FFh
	push eax
	mov eax, cc.rgbResult
	shr eax, 8
	and eax, 0FFh
	push eax
	mov eax, cc.rgbResult
	shr eax, 16
	push eax
; Set colors based upon color dialog selection
	mov eax, id	; Button ID.
	.if eax==BTN_TXT_CHO_CLR
		; Get text color
		pop txtBlue
		pop txtGreen
		pop txtRed
		; Set position of text Trackbars
		invoke SendMessage, hTBR_TXT_RED, TBM_SETPOS, TRUE, txtRed
		invoke SendMessage, hTBR_TXT_GREEN, TBM_SETPOS, TRUE, txtGreen
		invoke SendMessage, hTBR_TXT_BLUE, TBM_SETPOS, TRUE, txtBlue
	.else			
		; Get background color		
		pop bgdBlue
		pop bgdGreen
		pop bgdRed
		; Set position of background Trackbars
		invoke SendMessage, hTBR_BGD_RED, TBM_SETPOS, TRUE, bgdRed
		invoke SendMessage, hTBR_BGD_GREEN, TBM_SETPOS, TRUE, bgdGreen
		invoke SendMessage, hTBR_BGD_BLUE, TBM_SETPOS, TRUE, bgdBlue
	.endif
	invoke SendMessage, hWnd, WM_HSCROLL, 0, 0	; Reset trackbars and color based on selection.
	ret
SelectColor endp
; Copy color to clipboard
CopyColor proc id:DWORD
	LOCAL hGlobal:HGLOBAL
	LOCAL memBlock
	
	mov eax, id
	.if id==BTN_COPY_TXT_CLR
		invoke wsprintf, offset szBuffer, SADD("#%02X%02X%02X"), txtRed, txtGreen, txtBlue
	.else
		invoke wsprintf, offset szBuffer, SADD("#%02X%02X%02X"), bgdRed, bgdGreen, bgdBlue
	.endif
	
	invoke OpenClipboard, NULL
    .if (eax)
      	invoke EmptyClipboard
      	invoke GlobalAlloc, GMEM_MOVEABLE, SIZEOF szBuffer
      	.if (eax)
        	mov hGlobal, eax
        	invoke GlobalLock, hGlobal
          ;---------------------
          ; Pointer now in eax.
          ;---------------------
        	invoke MemCopy, ADDR szBuffer, eax, SIZEOF szBuffer
        	invoke GlobalUnlock, hGlobal
        	invoke SetClipboardData, CF_TEXT, hGlobal
          ;--------------------------------------------
          ; System now owns object identified by hGlobal.
          ;--------------------------------------------
        	.if (eax == 0)
         	 	invoke MessageBox, 0, SADD("SetClipboardData failed"), 0, MB_OK
        	.endif
      	.else
        	print "GlobalAlloc failed", 13, 10
      	.endif
      	invoke CloseClipboard
    .endif
	ret
CopyColor endp

